#define INCL_DOSSEMAPHORES /* Include semaphore services */
#define INCL_DOSPROCESS    /* Include thread stuff... /*
#include <os2.h>

int hSharedDataFile;
HMTX hmtx;

VOID CopyRecords1(ULONG uLong) {
   int hDataFile1 = OpenDataFile("datafile.1");

   /* Waiting for other thread to release mutex... */
   DosRequestMutexSem(hmtx, SEM_INDEFINITE_WAIT);
   /* At this point, this thread has rights to the file. */
   while (!eof(hDataFile1)) {
      /* Read record from hDataFile1 */
      /* Write record to shared data file */
   }
   CloseDataFile(hDataFile1);
   /* Release the mutex so the other thread can run... */
   DosReleaseMutexSem(hmtx);
}

VOID CopyRecords2(ULONG uLong) {
   int hDataFile2 = OpenDataFile("datafile.2");

   /* Waiting for other thread to release mutex... */
   DosRequestMutexSem(hmtx, SEM_INDEFINITE_WAIT);
   /* At this point, this thread has rights to the file. */
   while (!eof(hDataFile2)) {
      /* Read record from hDataFile2 */
      /* Write record to shared data file */
   }
   CloseDataFile(hDataFile2);
   /* Release the mutex so the other thread can run... */
   DosReleaseMutexSem(hmtx);
}

main() {
   TID atid[2];

   hSharedDataFile = OpenDataFile("datafile.shr");
   DosCreateMutexSem(NULL,   /* Anonymous mutex */
                     &hmtx,
                     0,      /* Private mutex */
                     FALSE); /* Initially unowned */
   DosCreateThread(&atid[0], CopyRecords1, ...);
   DosCreateThread(&atid[1], CopyRecords2, ...);
   DosWaitThread(&atid[0], DCWW_WAIT); /* Wait for threads */
   DosCloseMutexSem(hmtx); /* Close the mutex */
   CloseDataFile(hSharedDataFile);
}
